package cn.gov.customs.wxjy.analyze.service.impl;

import cn.gov.customs.cacp.sdks.core.user.trans.CacpTransUser;
import cn.gov.customs.wxjy.common.exception.ServiceException;
import cn.gov.customs.wxjy.common.utils.StringUtils;
import cn.gov.customs.wxjy.common.utils.bean.BeanValidators;
import cn.gov.customs.wxjy.common.utils.uuid.SnowflakeIdWorker;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import javax.validation.Validator;
import java.util.List;
import org.apache.commons.collections4.CollectionUtils;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import com.github.pagehelper.PageInfo;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import cn.gov.customs.wxjy.analyze.dao.NewDeclaredGoodsMapper;
import cn.gov.customs.wxjy.analyze.pojo.NewDeclaredGoods;
import cn.gov.customs.wxjy.analyze.pojo.NewDeclaredGoodsQuery;
import cn.gov.customs.wxjy.analyze.service.INewDeclaredGoodsService;

/**
 * 新申报商品提示Service业务层处理
 *
 * @author xiong
 * @date 2025-12-04
 */
@Service
@Slf4j
@RequiredArgsConstructor
public class NewDeclaredGoodsServiceImpl implements INewDeclaredGoodsService {

    private final NewDeclaredGoodsMapper newDeclaredGoodsMapper;

    private final Validator validator;

    /**
     * 查询新申报商品提示
     *
     * @param ID 新申报商品提示主键
     * @return 新申报商品提示
     */
    @Override
    public NewDeclaredGoods selectByID(String ID) {
        return newDeclaredGoodsMapper.selectByID(ID);
    }

    /**
     * 分页查询新申报商品提示列表
     *
     * @param query
     * @return 新申报商品提示
     */
    @Override
    public PageInfo<NewDeclaredGoods> selectPageList(NewDeclaredGoodsQuery query) {
        return PageInfo.of(newDeclaredGoodsMapper.selectList(query));
    }

    /**
     * 查询新申报商品提示列表
     *
     * @param query
     * @return 新申报商品提示
     */
    @Override
    public List<NewDeclaredGoods> selectList(NewDeclaredGoodsQuery query) {
        return newDeclaredGoodsMapper.selectList(query);
    }

    /**
     * 新增新申报商品提示
     *
     * @param newDeclaredGoods 新申报商品提示
     * @return 结果
     */
    @Override
    public int insert(NewDeclaredGoods newDeclaredGoods) {
            return newDeclaredGoodsMapper.insert(newDeclaredGoods);
    }

    /**
     * 修改新申报商品提示
     *
     * @param newDeclaredGoods 新申报商品提示
     * @return 结果
     */
    @Override
    public int update(NewDeclaredGoods newDeclaredGoods) {
        return newDeclaredGoodsMapper.update(newDeclaredGoods);
    }

    /**
     * 批量删除新申报商品提示
     *
     * @param ids 需要删除的新申报商品提示主键
     * @return 结果
     */
    @Override
    public int deleteByIDs(String[] ids) {
        return newDeclaredGoodsMapper.deleteByIDs(ids);
    }

    /**
     * 删除新申报商品提示信息
     *
     * @param ID 新申报商品提示主键
     * @return 结果
     */
    @Override
    public int deleteByID(String ID) {
        return newDeclaredGoodsMapper.deleteByID(ID);
    }

    /**
     * 逻辑删除新申报商品提示信息
     *
     * @param ID 新申报商品提示主键
     * @return 结果
     */
    @Override
    public int logicDelete(String ID) {

        return newDeclaredGoodsMapper.logicDelete(ID);
    }

    /**
     * 导入新申报商品提示数据
     *
     * @param newDeclaredGoodsList 新申报商品提示数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param cacpTransUser 操作用户
     * @return 结果
     */
    @Override
    public String importNewDeclaredGoods(List<NewDeclaredGoods> newDeclaredGoodsList, Boolean isUpdateSupport, CacpTransUser cacpTransUser) {
        if (CollectionUtils.isEmpty(newDeclaredGoodsList)) {
            throw new ServiceException("导入数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        for (NewDeclaredGoods newDeclaredGoods : newDeclaredGoodsList) {
            try {

                BeanValidators.validateWithException(validator, newDeclaredGoods);
                //id名称不统一，自行处理
                newDeclaredGoods.setCreateTime(DateUtils.getNowDate());
                newDeclaredGoods.setUpdateTime(DateUtils.getNowDate());
                newDeclaredGoods.setCreateUser(cacpTransUser.getUserId());
                newDeclaredGoods.setCreateDept(cacpTransUser.getParentGuid());

                newDeclaredGoodsMapper.insert(newDeclaredGoods);
                successNum++;
                successMsg.append("<br/>" + successNum + "、 " + cacpTransUser.getUserName() + " 导入成功");

            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + cacpTransUser.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
